/*
  Name : effect.hpp
  Copyright : KPAMEGAN & ROUSSET
  Authors : KPAMEGAN Karel, ROUSSET Baptiste
  Description: file which contents functions to make effects on a LCD screen
*/

#ifndef _effect_h_
#define _effect_h_

#include "base.hpp"

class Screen;

class Effect{
protected:
  Screen *myScreen;                                    //the screen which will be modify
  
public:
  Effect();                                            //this is a constructor
  Effect(Screen *screen);                              //this is a constructor
  ~Effect();                                           //this is the destructor
  void show_screen(void);                              //display the screen
  void pass_line_left(int nol,int nb);                 //make a line raveling on the left
  void pass_line_right(int nol,int nb);                //make a line raveling on the right
  void pass_screen_left(int nb);                       //make the screen raveling on the left
  void pass_screen_right(int nb);                      //make the screen raveling on the right
  void pass_screen_up(int nb);                         //make the screen raveling on the up
  void pass_screen_down(int nb);                       //make the screen raveling on the down

  void blink_area(int xs,int xe,int ys,int ye,int nb); //blinking a defined area on the screen
  void blink_line(int nol,int nb);                     //blinking a defined line
  void blink_screen(int nb);                           //blinking the screen

  void disappear_line_right(int nol);                  //disappear a line from left to right
  void disappear_screen_right(void);                   //disappear the screen from left to right
  void disappear_screen_up(void);                      //disappear the screen from down to up
  void disappear_screen_down(void);                    //disappear the screen from up to down
};

#endif

