/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#include "sock.h"

#include <iostream>
# include <stdio.h>

#include <netdb.h>
#include <errno.h>



/* Constructeur qui initialise la struc sockaddr_in */
Sock::Sock(string hostname, int port) {
	struct hostent *hostinfo; 

  this->name.sin_family = AF_INET;   /* Adresses IPV4 (Internet) */
  this->name.sin_port = htons (port); /* Configuration du port de connexion. On gère le little/big Endian */
  hostinfo = gethostbyname (hostname.c_str()); /* appeler les fonctions de résolution de nom de la libC */
  if (hostinfo == NULL) /* Si ne peut transformer le nom de la machine en adresse IP */
    {
      cout<< "Unknown host "<< hostname<<endl;
      exit (EXIT_FAILURE);
    }
  this->name.sin_addr = *(struct in_addr *) hostinfo->h_addr; /* Le dernier champs de la structure est garni */
}

/*Création et connexion de la socket*/
void Sock::connection() {
	/*Création de la socket*/
	this->sock=socket(PF_INET,SOCK_STREAM,6);
    if(sock==-1)
    { 
      perror("erreur creation socket\n");
      exit(errno);
    }
/*Connexion au serveur distant par la socket*/
  if ( connect(sock,(struct sockaddr *)&name,sizeof(name)) == -1)
    { 
      perror("connexion echoue");
      exit(errno);
    }
}

/*Envoi de la requete HTTP au serveur*/
void Sock::sendMsg(string message) {
	
	char codeRetour[4000];
	
	/*On ecrit la requete sur la socket*/
	if(write(sock,message.c_str(),message.size()+1)==-1)
   { 
		perror("pb d'ecriture sur la socket\n");
		exit(errno);
    }
	
	/*On recupere la reponse du serveur   Il faudrait l'analyser pour savoir ce qu'elle dit*/
	if (read(sock,codeRetour,1024)==-1)
	 {
	   perror("lecture echoue");
	   exit(errno);
	 }
	 printf("%s\n",codeRetour);
}

Sock::~Sock() {
	close(this->sock);
}
